/* SPDX-License-Identifier: GPL-2.0 */
/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 2005, 06 by Ralf Baechle (ralf@linux-mips.org)
 * Copyright (C) 2005 MIPS Technologies, Inc.
 * Copyright (C) 2020 Loongson Technology Co., Ltd.
 */
#ifndef _ASM_ABI_H
#define _ASM_ABI_H

#include <linux/signal_types.h>

#include <asm/signal.h>
#include <asm/siginfo.h>
#include <asm/vdso.h>

struct loongarch_abi {
	int (* const setup_frame)(void *sig_return, struct ksignal *ksig,
				  struct pt_regs *regs, sigset_t *set);
	int (* const setup_rt_frame)(void *sig_return, struct ksignal *ksig,
				     struct pt_regs *regs, sigset_t *set);
	const unsigned long	restart;
	const int audit_arch;

	unsigned int off_sc_fpregs;
	unsigned int off_sc_fcc;
	unsigned int off_sc_fcsr;
	unsigned int off_sc_vcsr;
	unsigned int off_sc_flags;

	struct loongarch_vdso_image *vdso;
#if defined(CONFIG_CPU_HAS_LBT)
	unsigned int off_sc_scr;
	unsigned int off_sc_eflags;
#endif
};

#endif /* _ASM_ABI_H */
